sbit rs at ra2_bit; sbit en at ra1_bit; sbit d4 at rc1_bit; sbit d5 at rc0_bit; sbit d6 at rc2_bit; sbit d7 at rc3_bit; // 

sbit i2cp at rc4_bit; //SCL i2c
sbit i2dp at rc5_bit; sbit i2dt at trisc5_bit; //SDA i2c
sbit op1  at ra0_bit; sbit ot1  at trisa0_bit; //    1-Wire

unsigned j1,j2,j3,fls;
//j1,j2,j3-  
//fls-  ()   
unsigned short i1,i2,i3,i4,i5,sst,mmt,hht,pg1,tc[2],td[2],kdd[16],nd1[2],dgh,ngh;
//i1,i2,i3-  
//i4,i5-  i2c  1-Wire
//sst,mmt,hht- (,,)
//pg1-  (     10)
//tc[]-    
//td[]-    
//kdd[]- 
//nd1[]-  ,  nd1[nm]=16;
//dgh-    (,)
//ngh-     (,)
unsigned short uv,un,ns1,nm1,ns2,nm2,mnu,tmv[8],vzr,vzp,mv1,flp,ssd;
//uv,un-  
//ns1- 
//nm1-  
//ns2,nm2-     
//mnu- 
//tmv[]- /  1,2
//vzr-   
//vzp-   
//mv1-   
//flp-    ()
//ssd-    ""
char tx1[6],tx2[8],tx3[8];
//tx1[]-    
//tx2[]- 
//tx3[]- 
bit tr1,tr2,vzv,flr;
//tr1-   ( 1)
//tr2-   ( 2)
//vzv-   ()
//flr-   ()
bit or,pg2,kr1,mg,ndk,srt,if1,if2,zn,v1,v2;
//or- /   1-Wire
//pg2-  
//kr1-   
//mg-   
//ndk- 
//srt-     1,2     
//if1,if2-   
//zn-   
//v1,v2- / 
bit k1,k2,k3,k4,k5,k6,k7,k8,bt1,bt2,bt3,bt4,bt5,bt6; //  

const char st0[]= //    
{
0x00,0x06,0x09,0x09,0x06,0x00,0x00,0x00, //      ( 0x00)
0x00,0x00,0x1e,0x11,0x1e,0x11,0x1e,0x00, // ""        ( 0x01)
0x00,0x00,0x11,0x12,0x1c,0x12,0x11,0x00, // ""        ( 0x02)
0x00,0x08,0x04,0x02,0x04,0x08,0x00,0x00, //    ( 0x03)
0x00,0x00,0x00,0x00,0x00,0x0c,0x04,0x08, //      ( 0x04)
0x00,0x00,0x10,0x10,0x1e,0x11,0x1e,0x00, // ""        ( 0x05)
};

const char st1[]= //  
{
0x42,0x70,0x65,0xbc,0xc7,0x20,0x20, //""
0x54,0x61,0xa6,0xbc,0x65,0x70,0x31, //"1"
0x54,0x61,0xa6,0xbc,0x65,0x70,0x32, //"2"
0x42,0x6f,0xb7,0xe3,0x79,0x78,0x20, //""
0xaa,0xb8,0xbb,0x05,0xbf,0x70,0x20, //""
};

void d2us() {delay_us(2);} //   2 
void d4us() {delay_us(4);} //   4 
void d5ms() {delay_ms(5);} //   5 
/////////////////////////////////////////////
void i2cst() {i2dp=1; i2cp=1; i2dt=0; d4us(); i2dp=0; d4us(); i2cp=0;} // i2c
void i2csp() {d2us(); i2dp=0; d2us(); i2cp=1; d4us(); i2dp=1;} // i2c
void i2cwr(unsigned short sm) //  i2c
{
or=1; do {if (or==0) i2cst(); i2dt=0; i2cp=0; for (i4=0; i4<8; i4++) {d2us(); i2dp=(sm>>(7-i4))&1; d2us(); i2cp=1; d4us(); i2cp=0;} // 
i2dp=0; i2dt=1; d4us(); i2cp=1; d4us(); or=0;} while(i2dp==1); i2dt=0; i2cp=0; //   
}
unsigned short i2crd(unsigned short sm) //  i2c
{
i2dt=1; i5=0; for (i4=0; i4<8; i4++) {d4us(); i5=(i2dp<<(7-i4))+i5; i2cp=1; d4us(); i2cp=0;} // 
if (sm==1) sm=0; else sm=1; i2dp=sm; i2dt=0; d4us(); i2cp=1; d4us(); i2cp=0; //    (1-  , 0- )
return i5;
}

void vrdat() // ,  , 
{
i2cst();      //    DS1307
i2cwr(0xd0);  //   
i2cwr(0x00);  //    
i2cst();      //  
i2cwr(0xd1);  //   
sst=i2crd(1); //0  - 
mmt=i2crd(1); //1  - 
hht=i2crd(0); //2  - 
i2csp();      //    DS1307
sst=bcd2dec(sst);mmt=bcd2dec(mmt);hht=bcd2dec(hht); //  -    
}

void vrkor() // 
{
if (pg1%10==0) i1=0; else i1=1;  //      
i2=pg1/10; if (pg2==1) i2=i2+i1; //   1      (2,5+2,5=2+3)
if (i2<9) i1=sst-(9-i2); else i1=sst+(i2-9); i1=dec2bcd(i1);
i2cst();     //    DS1307
i2cwr(0xd0); //   
i2cwr(0x00); //    
i2cwr(i1);   // 
i2csp();     //    DS1307
kr1=0; pg2=~pg2;
}
/////////////////////////////////////////////
void ons() {op1=0; ot1=0; delay_us(500); op1=1; ot1=1; while(op1==0); delay_us(430); ot1=0;} //  1-Wire
void onb(unsigned short on1) {if (on1==0) {op1=0; delay_us(90); op1=1; d2us();} else {op1=0; delay_us(10); op1=1; delay_us(80);}} // 0  1   1-Wire
void onr() {op1=0; d2us(); ot1=1; delay_us(10); or=op1; op1=1; ot1=0; delay_us(80);} //    1-Wire
void onwb(unsigned short on2) {for (i4=0; i4<8; i4++) onb((on2>>i4) & 1);} //    1-Wire
unsigned short onrb() {i5=0; for (i4=0; i4<8; i4++) {onr();i5=(or<<i4)+i5;} return i5;} //    1-Wire

void temp(unsigned short nm)
{
ons(); // 
onwb(0x55); for (i2=0; i2<8; i2++) onwb(kdd[i2+nm*8]); //  
onwb(0x44); //    
d5ms();
ons();
onwb(0x55); for (i2=0; i2<8; i2++) onwb(kdd[i2+nm*8]); //  
onwb(0xbe); //    
j1=onrb(); j1=(onrb()<<8)+j1; //  
for (i2=0; i2<6; i2++) nd1[nm]=onrb(); // 3-8     ( 8      )
if (nm==1) {if (j1 & 0x8000) {zn=0; j1=~j1+1;} else zn=1;} //   (zn=0-, zn=1-)
if (kdd[nm*8]==0x28) // DS18B20
{
tc[nm]=j1>>4; //   
j1=j1&15; j1=j1*625; td[nm]=j1/1000; //  ( )  
}
else // DS18S20
{
tc[nm]=j1>>1; //   
j1=j1&1; td[nm]=j1*5; //  ( )  
}
}
/////////////////////////////////////////////
void indwr(unsigned short sm,unsigned short dt) //   
{
rs=dt; //rs=0- , rs=1- 
d7=sm>>7; d6=sm>>6; d5=sm>>5; d4=sm>>4; d4us();en=1;d4us();en=0;
d7=sm>>3; d6=sm>>2; d5=sm>>1; d4=sm>>0; d4us();en=1;d4us();en=0;
d7=1; d6=1; d5=1; d4=1; d4us();d4us();
}

void indin() // 
{
d5ms();d5ms();d5ms();
for (i1=0; i1<3; i1++) {d7=0;d6=0;d5=1;d4=1; d4us();en=1;d4us();en=0; d5ms();} d4=0; d4us();en=1;d4us();en=0; //    
indwr(0x2a,0); //   4 , 2 , 58  ,  ( function set)
indwr(0x0c,0); // ,   ( display on/off control)
indwr(0x01,0); d5ms(); //  DDRAM
indwr(0x06,0); //  ,    DDRAM,  ( entry mode set)
indwr(0x13,0); // DC/DC 
for (i1=0; i1<48; i1++) {indwr(0x40+i1,0); indwr(st0[i1],1);} //     CGRAM 
}

void stroka1() {for (i1=0; i1<8; i1++) {indwr(0x80+i1,0); indwr(tx2[i1],1);}} // 1   
void stroka2() {for (i1=0; i1<8; i1++) {indwr(0xc0+i1,0); indwr(tx3[i1],1);}} // 2   
//    DDRAM (0x80+  -  ,0xc0+  -  ) ( write data to RAM)

void menu1(unsigned short n1,unsigned short n2) //       
{
tx2[0]=uv; j1=nm1*7+n1*7;                         for (i1=0; i1<7; i1++) tx2[i1+1]=st1[i1+j1]; //n1-    st1[]
tx3[0]=un; j1=nm1*7+n1*7+7; if (j1>n2*7) j1=n1*7; for (i1=0; i1<7; i1++) tx3[i1+1]=st1[i1+j1]; //n2-     st1[]
}
/////////////////////////////////////////////
void preob() {bytetostr(i3,tx1);} void srav() {if (i3<10) tx1[1]=0x30;}
/////////////////////////////////////////////
void but(unsigned short b) // 
{
if (rb3_bit==1) k1=1; if (k1==1 && rb3_bit==0) {bt1=1; k1=0;} //  
if (rb4_bit==0 && k2==1) {bt2=1; k2=0;} else k2=1; if (bt2==1) {if (uv==0x03) nm1--; if (nm1>b) nm1=b; ns1--; if (ns1>b) ns1=b;} //   ()
if (rb5_bit==0 && k3==1) {bt3=1; k3=0;} else k3=1; if (bt3==1) {if (un==0x03) nm1++; if (nm1>b) nm1=0; ns1++; if (ns1>b) ns1=0;} //   ()
if (rb7_bit==0) bt4=1; //  1
if (rb6_bit==0) bt5=1; //  1
if (re3_bit==1) k4=1; if (k4==1 && re3_bit==0) {bt6=1; k4=0;} //  
}
/////////////////////////////////////////////
void ottemp1() //  
{
i3=tc[0];preob(); tx3[1]=tx1[1]; tx3[2]=tx1[2]; tx3[3]=0x2e;
i3=td[0];preob(); tx3[4]=tx1[2]; tx3[5]=0x00;   tx3[6]=0x43;
}
void ottemp2() //  
{
if (tc[1]==0)            {tx3[1]=0x20;tx3[2]=0x20;tx3[3]=0x30;}
if (tc[1]>0 && tc[1]<10) {tx3[1]=0x20; if (zn==0) tx3[2]='-'; else tx3[2]='+'; i3=tc[1];preob(); tx3[3]=tx1[2];}
if (tc[1]>9)             {if (zn==0) tx3[1]='-'; else tx3[1]='+'; i3=tc[1];preob(); tx3[2]=tx1[1]; tx3[3]=tx1[2];}
tx3[4]=0x00;tx3[5]=0x43;tx3[6]=0x20;
}

void otinf() //   
{
but(0); bt2=0;bt3=0;bt4=0;bt5=0;bt6=0;

i3=hht;  preob(); srav(); tx2[0]=tx1[1];  tx2[1]=tx1[2];  tx2[2]=0x3a;
i3=mmt;  preob(); srav(); tx2[3]=tx1[1];  tx2[4]=tx1[2];  tx2[5]=0x3a;
i3=sst;  preob(); srav(); tx2[6]=tx1[1];  tx2[7]=tx1[2];
stroka1();

if (sst%5==0 && if2==1) {if1=~if1; if2=0;} if (sst%5) if2=1; if (nd1[0]!=16) if1=1; if (nd1[1]!=16) if1=0; //   
if (if1==0) ottemp1(); else ottemp2();
tx3[0]=0x20;tx3[7]=0x20;
if (nd1[0]!=16 && nd1[1]!=16) {for (i1=1;i1<7;i1++) tx3[i1]=0x20;}
stroka2();

if (rb4_bit==1) k5=1; if (k5==1 && rb4_bit==0) {tr1=~tr1; k5=0;} //  1
if (rb5_bit==1) k6=1; if (k6==1 && rb5_bit==0) {tr2=~tr2; k6=0;} //  2
if (rb7_bit==1) k7=1; if (k7==1 && rb7_bit==0) {vzv=~vzv; mv1=0; if (vzr==0) vzv=0; if (vzp==0) vzv=1; k7=0;} // 
if (rb6_bit==1) k8=1; if (k8==1 && rb6_bit==0) {flr=~flr; if (flp==0) flr=0; fls=0; k8=0;} // 

if (bt1==1) {mnu=1; nm1=0; ns1=0; uv=0x03; un=0x20; bt1=0;} //  
if (re3_bit==0) ssd++; else ssd=0; if (ssd>15) mnu=7; //  ""
}
/////////////////////////////////////////////
void mnnas() // ""
{
but(4); bt4=0; bt5=0;
if (bt2==1) {uv=0x03; un=0x20; bt2=0;} if (bt3==1) {uv=0x20; un=0x03; bt3=0;} menu1(0,4); stroka1(); stroka2();
if (bt1==1) {mnu=ns1+2; nm2=nm1; ns2=ns1; nm1=0; ns1=0; uv=0x03; un=0x20; bt1=0;} //   
if (bt6==1) {mnu=0; bt6=0;} //
}
/////////////////////////////////////////////
void ustvd() //   
{
but(4); bt1=0; bt2=0; bt3=0; if (ns1==0) {bt4=0; bt5=0;}
if (ns1==1) {if (bt4==1) {hht++; if (hht>23) hht=0;} if (bt5==1) {hht--; if (hht>23) hht=23;} i1=2; i2=hht;}
if (ns1==2) {if (bt4==1) {mmt++; if (mmt>59) mmt=0;} if (bt5==1) {mmt--; if (mmt>59) mmt=59;} i1=1; i2=mmt;}
if (ns1==3) {if (bt4==1 || bt5==1) sst=0; i1=0; i2=0;}
if (ns1==4)
{
if (bt4==1) {pg1=pg1+5; if (pg1>180) pg1=180; bt4=0;mg=0; eeprom_write(0x00,pg1);}
if (bt5==1) {pg1=pg1-5; if (pg1>180) pg1=0;   bt5=0;mg=0; eeprom_write(0x00,pg1);}
}

if ((bt4==1 || bt5==1) && ns1!=4)
{
i2=dec2bcd(i2); //     - 
i2cst();        //    DS1307
i2cwr(0xd0);    //   
i2cwr(i1);      //    
i2cwr(i2);      // 
i2csp();        //    DS1307
bt4=0; bt5=0; mg=0;
}

i3=hht;preob(); srav(); tx2[0]=tx1[1]; tx2[1]=tx1[2]; tx2[2]=0x3a; if (ns1==1 && mg==1) {tx2[0]=0x20; tx2[1]=0x20;}
i3=mmt;preob(); srav(); tx2[3]=tx1[1]; tx2[4]=tx1[2]; tx2[5]=0x3a; if (ns1==2 && mg==1) {tx2[3]=0x20; tx2[4]=0x20;}
i3=sst;preob(); srav(); tx2[6]=tx1[1]; tx2[7]=tx1[2];              if (ns1==3 && mg==1) {tx2[6]=0x20; tx2[7]=0x20;}
stroka1();
if (pg1<90) {i1=90-pg1; i2=0x2d;} else {i1=pg1-90; i2=0x2b;} i3=i1;preob(); srav(); tx3[2]=tx1[1];tx3[3]=0x04;tx3[4]=tx1[2];
if (i1!=0) tx3[1]=i2; else tx3[1]=0x20;
if (ns1==4 && mg==1) {tx3[1]=0x20;tx3[2]=0x20;tx3[3]=0x20;tx3[4]=0x20;}
tx3[0]=0x20;tx3[5]=0x20;tx3[6]=0x63;tx3[7]=0x2e;
stroka2();

if (bt6==1) {mnu=1; bt6=0; nm1=nm2; ns1=ns2; if (nm1==ns1) {uv=0x03; un=0x20;} else {uv=0x20; un=0x03;}} //
}
/////////////////////////////////////////////
void usttm(unsigned short nm) //  1,2 (nm+1- )
{
but(5); bt1=0; bt2=0; bt3=0; if (ns1==0 || ns1==5) {bt4=0; bt5=0; i1=0;} else i1=ns1-1; i2=i1+nm*4;
i1=59; if (ns1==1 || ns1==3) i1=23;

if (bt4==1) {tmv[i2]++; if (tmv[i2]>i1) tmv[i2]=0;  bt4=0;mg=0; eeprom_write(0x01+i2,tmv[i2]);}
if (bt5==1) {tmv[i2]--; if (tmv[i2]>i1) tmv[i2]=i1; bt5=0;mg=0; eeprom_write(0x01+i2,tmv[i2]);}

if (ns1<3) {tx2[0]=0x42;tx2[1]=0x02;tx2[2]=0xbb;tx2[3]=0x2e;tx2[4]=0x20;} else {tx2[0]=0x42;tx2[1]=0xc3;tx2[2]=0x02;tx2[3]=0xbb;tx2[4]=0x2e;}
tx2[5]=0x20;tx2[6]=0x20;tx2[7]=0x20; stroka1();

tx3[0]=0x20;tx3[1]=0x20;tx3[2]=0x20;tx3[5]=0x3a;
i2=(i2/4)*4;
if (ns1<3) i3=tmv[i2];   else i3=tmv[i2+2]; preob(); srav(); tx3[3]=tx1[1]; tx3[4]=tx1[2]; if ((ns1==1 || ns1==3) && mg==1) {tx3[3]=0x20; tx3[4]=0x20;}
if (ns1<3) i3=tmv[i2+1]; else i3=tmv[i2+3]; preob(); srav(); tx3[6]=tx1[1]; tx3[7]=tx1[2]; if ((ns1==2 || ns1==4) && mg==1) {tx3[6]=0x20; tx3[7]=0x20;}
stroka2();

if (bt6==1) {mnu=1; nm1=nm2; ns1=ns2; if (nm1==ns1) {uv=0x03; un=0x20;} else {uv=0x20; un=0x03;} bt6=0;} //
}
/////////////////////////////////////////////
void ustvz() // 
{
but(3); bt1=0; bt2=0; bt3=0;
if (ns1==0)
{
if (bt4==1) {vzr=vzr+5; if (vzr>240) vzr=240; eeprom_write(0x09,vzr);}
if (bt5==1) {vzr=vzr-5; if (vzr>240) vzr=0;   eeprom_write(0x09,vzr);}
}
if (ns1==1)
{
if (bt4==1) {vzp=vzp+5; if (vzp>240) vzp=240; eeprom_write(0x0a,vzp);}
if (bt5==1) {vzp=vzp-5; if (vzp>240) vzp=0;   eeprom_write(0x0a,vzp);}
}
if (ns1==2)
{
if (bt4==1) {dgh++; if (dgh>10) dgh=10; eeprom_write(0x0b,dgh);}
if (bt5==1) {dgh--; if (dgh<6)   dgh=6; eeprom_write(0x0b,dgh);}
}
if (ns1==3)
{
if (bt4==1) {ngh++; if (ngh>23) ngh=23; eeprom_write(0x0c,ngh);}
if (bt5==1) {ngh--; if (ngh<19) ngh=19; eeprom_write(0x0c,ngh);}
}
if (bt4==1 || bt5==1) {bt4=0; bt5=0;}

if (ns1==0) {tx2[0]=0x42;tx2[1]=0x02;tx2[2]=0xbb;tx2[3]=0x2e;tx2[4]=0x20;tx2[5]=0x20;}
if (ns1==1) {tx2[0]=0x42;tx2[1]=0xc3;tx2[2]=0x02;tx2[3]=0xbb;tx2[4]=0x2e;tx2[5]=0x20;}
if (ns1>1)  {tx2[0]=0x50;tx2[1]=0x61;tx2[2]=0xb2;tx2[3]=0x6f;tx2[4]=0xbf;tx2[5]=0x61;}
tx2[6]=0x20;tx2[7]=0x20;
stroka1();

if (ns1<2)
{
tx3[0]=0x20;tx3[1]=0x20;tx3[5]=0x20;tx3[6]=0xbc;tx3[7]=0x2e;
if (ns1==0) i3=vzr; else i3=vzp; preob(); tx3[2]=tx1[0]; tx3[3]=tx1[1]; tx3[4]=tx1[2];
}
else
{
if (ns1==2) {tx3[0]=0x20;tx3[1]=0x43;tx3[2]=0x20; i3=dgh;} else {tx3[0]=0xe0;tx3[1]=0x6f;tx3[2]=0x20; i3=ngh;}
preob(); srav(); tx3[3]=tx1[1];tx3[4]=tx1[2]; tx3[5]=0x3a;tx3[6]=0x30;tx3[7]=0x30;
}
stroka2();

if (bt6==1) {mnu=1; bt6=0; nm1=nm2; ns1=ns2; if (nm1==ns1) {uv=0x03; un=0x20;} else {uv=0x20; un=0x03;}} //
}
/////////////////////////////////////////////
void ustfl() // 
{
but(0); bt1=0; bt2=0; bt3=0;
if (bt4==1) {flp=flp+5; if (flp>120) flp=120; bt4=0; eeprom_write(0x0d,flp);}
if (bt5==1) {flp=flp-5; if (flp>120) flp=0;   bt5=0; eeprom_write(0x0d,flp);}

tx2[0]=0xa8;tx2[1]=0x61;tx2[2]=0x79;tx2[3]=0xb7;tx2[4]=0x61;tx2[5]=0x20;tx2[6]=0x20;tx2[7]=0x20; stroka1();

tx3[0]=0x20;tx3[1]=0x20;tx3[5]=0x20;tx3[6]=0xbc;tx3[7]=0x2e;
i3=flp; preob(); tx3[2]=tx1[0]; tx3[3]=tx1[1]; tx3[4]=tx1[2];
stroka2();

if (bt6==1) {mnu=1; bt6=0; nm1=nm2; ns1=ns2; if (nm1==ns1) {uv=0x03; un=0x20;} else {uv=0x20; un=0x03;}} //
}
/////////////////////////////////////////////
void ustdt() //     
{
but(1); bt1=0; bt2=0; bt3=0;
if (bt4==1)
{
ons(); //  1-Wire
onwb(0x33); //      (0x33)
d5ms(); for (i2=0; i2<8; i2++) {kdd[i2+ns1*8]=onrb(); eeprom_write(ns1*8+0x0e+i2,kdd[i2+ns1*8]);}
bt4=0;
}
if (bt5==1) {for (i2=0; i2<8; i2++) {kdd[i2+ns1*8]=0xff; eeprom_write(ns1*8+0x0e+i2,0xff);} bt5=0;}

tx2[0]=0xe0;tx2[1]=0x61;tx2[2]=0xbf;tx2[3]=0xc0;tx2[4]=0xb8;tx2[5]=0x02;tx2[6]=0x20;tx2[7]=0x31+ns1; stroka1();

for (i1=0;i1<8;i1++) tx3[i1]=0x20;
if (ns1==0 && nd1[0]==16) ottemp1(); if (ns1==1 && nd1[1]==16) ottemp2();
stroka2();

if (bt6==1) {ssd=0; mnu=0; bt6=0;} //
}
/////////////////////////////////////////////
void srvrm() //   ,  1,2,     
{
j3=hht*60+mmt;
tr1=0; j1=tmv[0]*60+tmv[1]; j2=tmv[2]*60+tmv[3]; if (j2<j1) j2=j2+1440; if (j3>=j1 && j3<j2) tr1=1; //  1
tr2=0; j1=tmv[4]*60+tmv[5]; j2=tmv[6]*60+tmv[7]; if (j2<j1) j2=j2+1440; if (j3>=j1 && j3<j2) tr2=1; //  2
srt=0;
}
/////////////////////////////////////////////
void rele() /// 
{
if (tmv[0]==hht && tmv[1]==mmt && sst==0) tr1=1; //   1
if (tmv[2]==hht && tmv[3]==mmt && sst==0) tr1=0; //  1
if (tmv[4]==hht && tmv[5]==mmt && sst==0) tr2=1; //   2
if (tmv[6]==hht && tmv[7]==mmt && sst==0) tr2=0; //  2

if (flp>0) {if (fls>=flp*60 && flr==0) flr=1;} else {flr=0; fls=0;} // 

if (hht>=dgh && hht<ngh) // 
{
if (vzr>0) // 
{
if (vzr!=0 && vzp==0) {vzv=1; v1=1;} //  
if (vzr!=0 && vzp!=0) // ,  
{
if (v1==1) {vzv=1; v1=0;} //      
if (sst==59 && v2==1) {mv1++; v2=0;} if (sst==0) v2=1; //   
if (mv1>=vzp && vzv==0 && sst==0) {mv1=0; vzv=1;} //
if (mv1>=vzr && vzv==1 && sst==0) {mv1=0; vzv=0;} //
}
} else {vzv=0; v1=1; mv1=0;}
}
else // 
{
vzv=0; v1=1; mv1=0;
}
}
/////////////////////////////////////////////
void eepr() //   EEPROM 
{
pg1=eeprom_read(0x00);
for (i1=0; i1<8; i1++)  tmv[i1]=eeprom_read(i1+0x01);
vzr=eeprom_read(0x09);
vzp=eeprom_read(0x0a);
dgh=eeprom_read(0x0b);
ngh=eeprom_read(0x0c);
flp=eeprom_read(0x0d);
for (i1=0; i1<16; i1++) kdd[i1]=eeprom_read(i1+0x0e);
}
/////////////////////////////////////////////


void main() 
{
osccon=0x70; //8 
ansel=0x00;anselh=0x00;c1on_bit=0;c2on_bit=0;
porta=0x00; trisa=0x00; portb=0x00;trisb=0xf8; portc=0x00;trisc=0x00;
porta.b4=~porta.b4; porta.b4=0; porta.b7=1; //  
not_rbpu_bit=0; wpub=0xf8;
d5ms();d5ms();d5ms();d5ms(); eepr(); //   EEPROM 
indin(); // 

nm1=0;ns1=0;mnu=0;nd1[0]=0;nd1[1]=0;mv1=0;tc[0]=50;ssd=0;
flr=1; pg2=0;srt=1; bt1=0;bt2=0;bt3=0;bt4=0;bt5=0;bt6=0; k2=0;k3=0; v1=1; ndk=0;
do
{
delay_ms(200);
mg=~mg;
i1=sst; vrdat(); if (i1!=sst) fls++; // ,      
if (hht!=0 && sst==0) kr1=1; if (kr1==1 && hht==0 && mmt==0 && sst==30) vrkor(); // 
if (mnu==0)           otinf();      //   
if (mnu==1)           mnnas();      // ""
if (mnu==2)           ustvd();      //    
if (mnu==3 || mnu==4) usttm(mnu-3); //  1,2
if (mnu==5)           ustvz();      // 
if (mnu==6)           ustfl();      // 
if (mnu==7)           ustdt();      //   

ndk=~ndk; temp(ndk);
if (srt==1) srvrm(); //   1,2
rele(); /// 

porta.b6=0;   porta.b5=~porta.b5; porta.b5=0;
porta.b6=0;   porta.b5=~porta.b5; porta.b5=0;
porta.b6=0;   porta.b5=~porta.b5; porta.b5=0;
porta.b6=flr; porta.b5=~porta.b5; porta.b5=0;
porta.b6=vzv; porta.b5=~porta.b5; porta.b5=0;
porta.b6=tr1; porta.b5=~porta.b5; porta.b5=0;
porta.b6=tr2; porta.b5=~porta.b5; porta.b5=0;
porta.b6=0;   porta.b5=~porta.b5; porta.b5=0;
porta.b4=~porta.b4; porta.b4=0; //       
}
while(1);
}